#include "main.h"

volatile int bSleep=0;
int bMenu=0;

char RinPath[MAXPATH];
char RomPath[MAXPATH];
char RomName[MAXNAME];
char SavePath[MAXPATH];

// ----------------------------------------------------------------------------------------

// z[{^IɃR[obN
int exit_callback(void)
{
#ifdef OVER_CLOCK
	scePowerSetClockFrequency(222,222,111);
#endif
	bSleep=1;
	save_config();
	if (rom_get_loaded() && rom_has_battery())
		save_sram(get_sram(), rom_get_info()->ram_size);
	
	sceKernelExitGame();
	return 0;
}

// X[vsɃR[obN
void power_callback(int unknown, int pwrflags)
{
	if(pwrflags & POWER_CB_POWER){
		bSleep=1;
#ifdef OVER_CLOCK
		scePowerSetClockFrequency(222,222,111);
#endif
		save_config();
		if (rom_get_loaded() && rom_has_battery())
			save_sram(get_sram(), rom_get_info()->ram_size);
	}else if(pwrflags & POWER_CB_RESCOMP){
		bSleep=0;
	}
	// R[obN֐̍ēo^
	// ixĂ΂ꂽēo^ƂȂƎɃR[obNȂj
	int cbid = sceKernelCreateCallback("Power Callback", power_callback);
	scePowerRegisterCallback(0, cbid);
}

// |[OpXbh
int CallbackThread(int args, void *argp)
{
	int cbid;
	
	// R[obN֐̓o^
	cbid = sceKernelCreateCallback("Exit Callback", exit_callback);
	SetExitCallback(cbid);
	cbid = sceKernelCreateCallback("Power Callback", power_callback);
	scePowerRegisterCallback(0, cbid);
	
	// |[O
	sceKernelPollCallbacks();
}

int SetupCallbacks(void)
{
	int thid = 0;
	
	// |[OpXbh̐
	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
		sceKernelStartThread(thid, 0, 0);
	
	return thid;
}

// ----------------------------------------------------------------------------------------

int xmain(int argc, char *argv)
{
	const unsigned int sync_time=16666;
	unsigned long prev_time, cur_time, next_time;
	unsigned long waitfc=0;
	int fd, romsize, ramsize, line, i, bDraw, turbo_bak=0;
	char *p, savedir[MAXPATH];
	
	pgInit();
	
	_strcpy(RinPath, argv);
	p = _strrchr(RinPath, '/');
	*++p = 0;
	
	SetupCallbacks();
	pgScreenFrame(2,0);
	wavoutInit();
	
	load_config();
	load_menu_bg();
	bgbright_change();
	if(setting.sound) wavout_enable=1;

	_strcpy(savedir,RinPath);
	_strcat(savedir,"SAVE");
	sceIoMkdir(savedir,0777);
	
	gb_init();
	for(;;){
		while(!getFilePath(RomPath))
			;
		// w肵t@C[hB by ruka
		romsize = load_rom(RomPath);
		if (!romsize) continue;
		ramsize = load_sram();
		if(gb_load_rom(rom_image, romsize, sram_space, ramsize))
			break;
	}
	render_msg_mode = 6;
	render_msg_time = sceKernelLibcClock();
	if(org_gbtype==1)
		_strcpy(render_msg, "ROM TYPE:GB");
	else if(org_gbtype==2)
		_strcpy(render_msg, "ROM TYPE:SGB");
	else if(org_gbtype==3)
		_strcpy(render_msg, "ROM TYPE:GBC");

	pgFillvram(0);
	pgScreenFlipV();
	pgFillvram(0);
	pgScreenFlipV();

#ifdef DEBUG
	unsigned long lasttick;
	unsigned long framecount;
	unsigned long lastclock=sceKernelLibcClock();
#endif
	
	cur_time = sceKernelLibcClock();
	prev_time = cur_time;
	next_time = cur_time + sync_time;
	
#ifdef OVER_CLOCK
	set_cpu_clock();
#endif
	
	for(;;) {
		for(line=0; line<154; line++)
			gb_run();
		
		cur_time = sceKernelLibcClock();
#ifdef DEBUG
		framecount++;
		if (framecount>=60) {
			unsigned long l;

			//t[[g̎wWB60t[ł(usec)PUiŕ\B
			//tt[0x000f4240ƂȂA傫ƒxƂɂȂB𑜓x̂͊فB - LCK
			framecount=0;
			
			pgcLocate(50,0);
			pgcPuthex8(cur_time-lasttick);
			lasttick=cur_time;
			
			pgcLocate(50,2);
			pgcPuthex8(c_regs_PC);
			l=(cpu_read_direct(c_regs_PC)<<24)+(cpu_read_direct(c_regs_PC+1)<<16)+(cpu_read_direct(c_regs_PC+2)<<8)+(cpu_read_direct(c_regs_PC+3));
			pgcLocate(50,3);
			pgcPuthex8(l);

			unsigned long curclock=cpu_get_clock();
			pgcLocate(50,5);
			pgcPuthex8(cur_time-lastclock);
			lastclock=cur_time;

			pgcLocate(50,25);
			pgcPuthex8(g_regs.IF);
			pgcLocate(50,26);
			pgcPuthex8(g_regs.IE);
			extern byte c_regs_I;
			pgcLocate(50,27);
			pgcPuthex8(c_regs_I);
			
			// kmg
			pgcLocate(2, 2);
			pgcPuthex8(paddata.analog[CTRL_ANALOG_X]);
			pgcLocate(2, 3);
			pgcPuthex8(paddata.analog[CTRL_ANALOG_Y]);
			
			// ԊOfoCX
			pgcLocate(2, 5);
			extern int rp_fd;
			pgcPuthex8(rp_fd);
			pgcLocate(2, 6);
			extern byte rp_data;
			pgcPuthex8(rp_data);
			pgcLocate(2, 7);
			extern unsigned long rp_time;
			pgcPuthex8(rp_time);
		}
		pgScreenFlip();
#else
		if (bTurbo){
			turbo_bak = 1;
			skip++;
			if (skip > 9){
				skip = 0;
				prev_time = cur_time;
			}
		}else if (cur_time > next_time){
			skip++;
			if(skip > setting.frameskip){
				skip=0;
				if(setting.vsync){
					sceDisplayWaitVblank();
					cur_time = sceKernelLibcClock();
				}
				prev_time = cur_time;
			}
		}else{
			if(setting.vsync){
				sceDisplayWaitVblank();
				cur_time = sceKernelLibcClock();
				prev_time = cur_time;
			}else{
				waitfc++;
				while(cur_time < prev_time+10000*(skip+1))
					cur_time = sceKernelLibcClock();
				if (!(waitfc&3)){
					while(cur_time < next_time)
						cur_time = sceKernelLibcClock();
				}
				prev_time = next_time;
			}
			skip=0;
		}
		next_time = prev_time + sync_time * (skip+1);
		if (setting.vsync && !bTurbo){
			if (turbo_bak)
				turbo_bak = 0;
			else if (skip==0) 
				pgScreenFlip();
		}else{
			if (now_frame==0) pgScreenFlip();
		}
#endif
		
		// j[
		if(bMenu){
			wavout_enable=0;
#ifdef OVER_CLOCK
			scePowerSetClockFrequency(222,222,111);
#endif
			rin_menu();
#ifdef OVER_CLOCK
			set_cpu_clock();
#endif
			cur_time = sceKernelLibcClock();
			prev_time = cur_time;
			next_time = cur_time + sync_time;
			bMenu = 0;
			if(setting.sound) wavout_enable=1;
		}
		
		// X[v
		if(bSleep){
			wavout_enable=0;
			while(bSleep)
				pgWaitV();
#ifdef OVER_CLOCK
			set_cpu_clock();
#endif
			cur_time = sceKernelLibcClock();
			prev_time = cur_time;
			next_time = cur_time + sync_time;
			if(setting.sound) wavout_enable=1;
		}
	}

	return 0;
}
