#include "main.h"

int pad_state;
int cur_time;
dword fixed_time;
bool b_pad_update;
bool b_time_fix;
int now_sensor_x,now_sensor_y;
int rapid_state = 0;

char render_msg[128];
int render_msg_mode;
long render_msg_time;

const char *scr_names[] = {
	"x1",
	"x1.5 (filtered)",
	"x2 (uncropped)",
	"x2 (fit)",
	"x2 (scanline)",
	"x2 (uncropped without top)",
	"x2 (uncropped without bottom)",
	"FULL",
};

#define GBWIDTH  160
#define GBHEIGHT 144

//vframe`ύXɔvC - LCK
//eXN[[hɂĂCKvȂ̂Œӂ̂
//word vframe[(8+160+8)*(144+100)];
//EɂWhbgÂ̃K[hGA݂Bgb.cbufvframe+8ƂČĂԂ̂ŁAesE16hbg̃K[hGAƈ
void render_screen(void *buf)
{
	if(render_msg_mode!=0 && render_msg_mode!=3){
		pgFillBox(0,263,479,271,0);
		render_msg_mode--;
	}
	
	switch(setting.screensize){
		case SCR_X1:
			if (border_uploaded && now_gb_mode==2){
				pgBitBltSgb(112,24,(unsigned long *)sgb_border_buffer);
				border_uploaded--;
			}
			pgBitBltN1(160,64,(unsigned long *)buf);
			break;
		case SCR_X15:
			pgBitBltN15(120,28,(unsigned long *)buf);
			break;
		case SCR_X2_UNCROPED:
			pgBitBltN2(80,0,GBHEIGHT-8,(unsigned long *)(buf+(GBWIDTH+16)*4));
			break;
		case SCR_X2_FIT:
			pgBitBltSt2Fix(80,0,GBHEIGHT,2,(unsigned short *)buf);
			break;
		case SCR_X2_SCANLINE:
			pgBitBltStScan(80,0,GBHEIGHT-8,(unsigned long *)(buf+(GBWIDTH+16)*4));
			break;
		case SCR_X2_UTOP:
			pgBitBltSt2wotop(80,0,GBHEIGHT,(unsigned long *)buf);
			break;
		case SCR_X2_UBOTTOM:
			pgBitBltSt2wobot(80,0,GBHEIGHT,(unsigned long *)buf);
			break;
		case SCR_FULL:
			pgBitBltStFull(0,0,GBHEIGHT,3,(unsigned short *)buf);
			break;
		default:
			pgBitBltN1(160,64,(unsigned long *)buf);
	}
	
	if(render_msg_mode>=3){
		pgPrint_drawbg(0,33,0xffff,0,render_msg);
		if (sceKernelLibcClock() > render_msg_time + 1000000)
			render_msg_mode=2;
	}
}

//SoNɕāAݏo͒ȂoNɏĂ - LCK
void renderer_update_sound()
{
	/*
	static unsigned int nextbank=1;
	unsigned int playbank=cur_play/SOUND_BANKLEN;
	if (nextbank!=playbank) {
		snd_render(&sound_buf[nextbank*SOUND_BANKLEN*2],SOUND_BANKLEN);
		nextbank=((nextbank+1)&3);
	}
	*/

	int sound_buf_len = (1024 + 1024 * setting.sound_buffer) ;
	static unsigned int nextbank=1;
	unsigned int playbank=cur_play/sound_buf_len;
	if (nextbank!=playbank) {
		snd_render(&sound_buf[nextbank*sound_buf_len*2],sound_buf_len);
		nextbank++;
		if( (sound_buf_len * (nextbank+1)) > (SOUND_BANKLEN*4) ){ nextbank = 0; }
	}
}

#define UPPER_THRESHOLD  0xcf
#define LOWER_THRESHOLD  0x2f
void renderer_update_pad()
{
	static int m=0;
	static int bPad=0;
	static int key_dat_buf=0;
	
	rapid_state = (rapid_state + 1) % 4;
	
	pad_state=0;
	sceCtrlPeekBufferPositive(&paddata, 1);
	if(setting.skeys[2].buttons && (paddata.buttons&setting.skeys[2].buttons)==setting.skeys[2].buttons)
		pad_state|=1 * (rapid_state/2);  // by kwn
	else if(setting.skeys[0].buttons && (paddata.buttons&setting.skeys[0].buttons)==setting.skeys[0].buttons)
		pad_state|=1;
	if(setting.skeys[3].buttons && (paddata.buttons&setting.skeys[3].buttons)==setting.skeys[3].buttons)
		pad_state|=2 * (rapid_state/2);  // by kwn
	else if(setting.skeys[1].buttons && (paddata.buttons&setting.skeys[1].buttons)==setting.skeys[1].buttons)
		pad_state|=2;
	if(setting.skeys[4].buttons && (paddata.buttons&setting.skeys[4].buttons)==setting.skeys[4].buttons)
		pad_state|=4;
	if(setting.skeys[5].buttons && (paddata.buttons&setting.skeys[5].buttons)==setting.skeys[5].buttons)
		pad_state|=8;
	if(paddata.buttons & CTRL_DOWN)  pad_state|=16;
	if(paddata.buttons & CTRL_UP)    pad_state|=32;
	if(paddata.buttons & CTRL_LEFT)  pad_state|=64;
	if(paddata.buttons & CTRL_RIGHT) pad_state|=128;
	
	// kmg
	// Analog pad state
	if(setting.analog2dpad){
		if (paddata.analog[CTRL_ANALOG_Y] > UPPER_THRESHOLD) pad_state|=0x10; // DOWN
		if (paddata.analog[CTRL_ANALOG_Y] < LOWER_THRESHOLD) pad_state|=0x20; // UP
		if (paddata.analog[CTRL_ANALOG_X] < LOWER_THRESHOLD) pad_state|=0x40; // LEFT
		if (paddata.analog[CTRL_ANALOG_X] > UPPER_THRESHOLD) pad_state|=0x80; // RIGHT
	}
	
	int n = get_nShortcutKey(paddata.buttons);
	if(n == -1)
		bPad = 1;
	else{
		if(!bPad) n = -1;
		bPad = 0;
		pad_state=0;
		
		switch(n)
		{
		case -1:
			break;
		case 6:
			bMenu = 1;
			break;
		case 7:
			bTurbo = !bTurbo;
			if(bTurbo)
				_strcpy(render_msg,"TURBO:ON");
			else
				_strcpy(render_msg,"TURBO:OFF");
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			bPad=0;
			break;
		case 8:
			setting.vsync = !setting.vsync;
			if(setting.vsync)
				_strcpy(render_msg,"VSYNC:ON");
			else
				_strcpy(render_msg,"VSYNC:OFF");
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			break;
		case 9:
			setting.sound = !setting.sound;
			wavout_enable = setting.sound;
			if(setting.sound)
				_strcpy(render_msg,"SOUND:ON");
			else
				_strcpy(render_msg,"SOUND:OFF");
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			break;
		case 10:
			for(;;){
				if (++setting.screensize >= SCR_END) setting.screensize=0;
				if (setting.bScreenSizes[setting.screensize]) break;
			}
			_strcpy(render_msg,"SCREEN SIZE:");
			_strcat(render_msg,scr_names[setting.screensize]);
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			pgFillvram(0);
			pgScreenFlip();
			pgFillvram(0);
			pgScreenFlip();
			border_uploaded = 2;
			break;
		case 11:
#ifdef OVER_CLOCK
			scePowerSetClockFrequency(222,222,111);
#endif
			wavout_enable=0; // kmg
			// by Smiths
			if(save_state(QuickSlot))
				_strcpy(render_msg,"Save State at 0");
			else
				_strcpy(render_msg,"State Save Failed at 0");
			render_msg[_strlen(render_msg)-1] = QuickSlot+'0';
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			if(setting.sound) wavout_enable=1; // kmg
#ifdef OVER_CLOCK
			set_cpu_clock();
#endif
			break;
		case 12:
#ifdef OVER_CLOCK
			scePowerSetClockFrequency(222,222,111);
#endif
			wavout_enable=0; // kmg
			// by Smiths
			if(load_state(QuickSlot))
				_strcpy(render_msg,"Load State at 0");
			else
				_strcpy(render_msg,"State Load Failed at 0");
			render_msg[_strlen(render_msg)-1] = QuickSlot+'0';
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			if(setting.sound) wavout_enable=1; // kmg
#ifdef OVER_CLOCK
			set_cpu_clock();
#endif
			break;
		case 13:
			if (++QuickSlot > STATE_SLOT_MAX) QuickSlot=0;
			_strcpy(render_msg,"Quick Slot:0");
			render_msg[11]=QuickSlot+'0';
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			bPad=0;
			break;
		case 14:
			if (rom_get_info()->gb_type!=1 && now_gb_mode==1){
				for(;;){
					if (++setting.gb_palette >= PAL_SGB) setting.gb_palette=1;
					if (setting.bGB_Colors[setting.gb_palette]) break;
				}
				lcd_set_mpal(setting.gb_palette);
				_strcpy(render_msg,"GB PALETTE:");
				_strcat(render_msg,pal_names[setting.gb_palette]);
				render_msg_mode = 5;
				render_msg_time = sceKernelLibcClock();
			}
			break;
#ifdef OVER_CLOCK
		case 15:
			if(++setting.cpu_clock > 2) setting.cpu_clock=0;
			set_cpu_clock();
			_strcpy(render_msg,"CPU CLOCK:");
			_strcat(render_msg,cpu_clocks[setting.cpu_clock]);
			render_msg_mode = 5;
			render_msg_time = sceKernelLibcClock();
			break;
#endif
		}
	}
	// [VZT[
	now_sensor_x=2047-paddata.analog[CTRL_ANALOG_X]+127;
	now_sensor_y=2047-paddata.analog[CTRL_ANALOG_Y]+127;
}

void renderer_refresh()
{
	if (b_pad_update)
		renderer_update_pad();

	renderer_update_sound();
}

void renderer_init()
{
	cur_time=0;
	fixed_time=0;
	b_pad_update=true;
	b_time_fix=false;
	render_msg[0]=0;
	render_msg_mode=0;
	
	renderer_reset();
}

void renderer_reset()
{
	pad_state=0;
	now_sensor_x=now_sensor_y=2047;
}

/*
int renderer_check_pad()
{
	return pad_state;
}
*/
byte renderer_get_time(int type)
{
	unsigned long now=sceKernelLibcTime(NULL)-cur_time;

	switch(type){
	case 8: // b
		return (byte)(now%60);
	case 9: // 
		return (byte)((now/60)%60);
	case 10: // 
		return (byte)((now/(60*60))%24);
	case 11: // (L)
		return (byte)((now/(24*60*60))&0xff);
	case 12: // (H)
		return (byte)((now/(256*24*60*60))&1);
	}
	return 0;
}

void renderer_set_time(int type,byte dat)
{
	unsigned long now=sceKernelLibcTime(NULL);
	unsigned long adj=now-cur_time;

	switch(type){
	case 8: // b
		adj=(adj/60)*60+(dat%60);
		break;
	case 9: // 
		adj=(adj/(60*60))*60*60+(dat%60)*60+(adj%60);
		break;
	case 10: // 
		adj=(adj/(24*60*60))*24*60*60+(dat%24)*60*60+(adj%(60*60));
		break;
	case 11: // (L)
		adj=(adj/(256*24*60*60))*256*24*60*60+(dat*24*60*60)+(adj%(24*60*60));
		break;
	case 12: // (H)
		adj=(dat&1)*256*24*60*60+(adj%(256*24*60*60));
		break;
	}
	cur_time=now-adj;
}

void renderer_set_bibrate(bool bibrate)
{
}

word renderer_get_sensor(bool x_y)
{
	return (x_y?(now_sensor_x&0x0fff):(now_sensor_y&0x0fff));
}

int renderer_get_timer_state()
{
	return cur_time;
}

void renderer_set_timer_state(int timer)
{
	cur_time=timer;
}
